package net.peachjean.slf4j.mojo;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.plugin.MojoFailureException;

public abstract class AbstractLoggingMojo extends AbstractMojo
{
	@Override
	public final void execute() throws MojoExecutionException, MojoFailureException
	{
		try
		{
			CurrentMojoLogger.doWithLog(this.getLog(), new Runnable()
			{
				@Override
				public void run()
				{
					try
					{
						AbstractLoggingMojo.this.executeWithLogging();
					}
					catch (MojoExecutionException e)
					{
						throw new RuntimeException(e);
					}
					catch (MojoFailureException e)
					{
						throw new RuntimeException(e);
					}
				}
			});
		}
		catch (RuntimeException e)
		{
			throwIfMojoException(e.getCause());
			throw new MojoExecutionException("Mojo failed to execute.", e);
		}
		catch (Exception e)
		{
			throwIfMojoException(e);
			throw new MojoExecutionException("Mojo failed to execute.", e);
		}
	}

	private void throwIfMojoException(Throwable e) throws MojoExecutionException, MojoFailureException {
		if(e.getCause() instanceof MojoExecutionException) {
			throw (MojoExecutionException) e.getCause();
		} else if(e.getCause() instanceof MojoFailureException) {
			throw (MojoFailureException) e.getCause();
		}
	}

	protected abstract void executeWithLogging() throws MojoExecutionException, MojoFailureException;
}
